/*************************************************************************

    Vendetta

*************************************************************************/

class vendetta_state
{
public:
	static void *alloc(running_machine &machine) { return auto_alloc_clear(&machine, vendetta_state(machine)); }

	vendetta_state(running_machine &machine) { }

	/* memory pointers */
	UINT8 *    ram;
//  UINT8 *    paletteram;    // currently this uses generic palette handling

	/* video-related */
	int        layer_colorbase[3], sprite_colorbase;
	int        layerpri[3];

	/* misc */
	int        irq_enabled;
	offs_t     video_banking_base;

	/* devices */
	running_device *maincpu;
	running_device *audiocpu;
	running_device *k053260;
	running_device *k052109;
	running_device *k053246;
	running_device *k053251;
	running_device *k054000;
};

/*----------- defined in video/vendetta.c -----------*/

extern void vendetta_tile_callback(running_machine *machine, int layer,int bank,int *code,int *color,int *flags,int *priority);
extern void esckids_tile_callback(running_machine *machine, int layer,int bank,int *code,int *color,int *flags,int *priority);
extern void vendetta_sprite_callback(running_machine *machine, int *code,int *color,int *priority_mask);

VIDEO_UPDATE( vendetta );
